from subprocess import Popen, PIPE
import json
from datetime import datetime

from PySide.QtCore import *

# notmuch = "/home/olivier/bin/notmuch"
notmuch = "/usr/local/bin/notmuch"

class Search(QThread):
    thread = Signal(str)
    
    def __init__(self, query, parent=None):
        QThread.__init__(self, parent)
        self._query = query
    
    def run(self):
        self._process = Popen([notmuch, "search", "--format=json", "--output=summary", self._query], stdout=PIPE, stderr=None)
        
        for line in self._process.stdout:
            self.thread.emit(line.decode("UTF-8"))
    
    def terminate(self):
        self._process.terminate()

class Show(object):
    def __init__(self, query):
        self._query = query
        self._data = self.run()
    
    def run(self):
        self._process = Popen([notmuch, "show", "--format=json", self._query], stdout=PIPE, stderr=None)
        
        # TODO: use a buffer here
        data = "".join(self._process.stdout.readlines())
        data = data.decode("UTF-8")
        data = json.loads(data)
        return data
    
    def walk(self, thread=None, deep=0):
        if thread is None:
            thread = self._data[0][0]
        
        msg, replies = thread
        yield deep, msg
        
        for reply in replies:
            # yield results from the recursive calls
            for x in self.walk(reply, deep + 1):
                yield x


